package com.cit.sellfan.ui.view.cliente04.centrifighi;

import cit.sellfan.classi.Accessorio;
import com.cit.sellfan.business.VariabiliGlobali;
import com.cit.sellfan.ui.view.AccessoriFreeView;
import com.vaadin.shared.ui.MarginInfo;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.CustomComponent;
import com.xdev.ui.XdevButton;
import com.xdev.ui.XdevGridLayout;
import com.xdev.ui.XdevHorizontalLayout;
import com.xdev.ui.XdevPanel;
import com.xdev.ui.XdevVerticalLayout;
import com.xdev.ui.XdevView;

public class Cliente04AccessoriViewFusione extends XdevView {
	private VariabiliGlobali l_VG;
	private String modelloOld = "";
	private final Cliente04AccessoriViewTuttiFusione accessoriViewTutti = new Cliente04AccessoriViewTuttiFusione();
	private final AccessoriFreeView accessoriFreeView = new AccessoriFreeView();
	private final String coloreBottone = "verde";
	private final String coloreBottoneSelezionato = "verdeselezionato";

	/**
	 * 
	 */
	public Cliente04AccessoriViewFusione() {
		super();
		this.initUI();
	}
        
        public void togglePreventivoButton(boolean value) {
            accessoriViewTutti.buttonAggiungiPreventivo.setEnabled(value);
        }
	
	public void refreshAccessori() {
		setVentilatoreCurrent();
	}
	
	public boolean isPreSetVentilatoreCurrentOK() {
		if (this.l_VG == null) {
			return false;
		}
		if (this.l_VG.VentilatoreCurrent == null || this.l_VG.utilityCliente == null || !this.l_VG.utilityCliente.isTabVisible("Accessori")) {
			return false;
		}
		if (this.l_VG.VentilatoreCurrent.selezioneCorrente.ElencoAccessori.size() <= 0) {
			return false;
		}
		return true;
	}
	
	public void setVentilatoreCurrent() {
	    this.l_VG.ElencoView[this.l_VG.AccessoriViewIndex] = this;
	    this.l_VG.ElencoMobileView[this.l_VG.AccessoriViewIndex] = null;
		this.accessoriViewTutti.setVentilatoreCurrentCaratteristiche();
		this.accessoriViewTutti.setVentilatoreCurrent(this.l_VG.elencoGruppiAccessori.get(0).descrizioneGruppo);
		this.accessoriFreeView.setVentilatoreCurrent();
		if (!this.l_VG.VentilatoreCurrent.ModelloTrans.equals(this.modelloOld)) {
			buttonTab0_buttonClick(null);
		}
		this.modelloOld = this.l_VG.VentilatoreCurrent.ModelloTrans;
	}
        
	public void setMPF(Accessorio acc) {
            accessoriViewTutti.setMPF(acc);
        }
        
	public void Nazionalizza() {
		this.buttonTab0.setCaption(this.l_VG.utilityTraduzioni.TraduciStringa(this.l_VG.elencoGruppiAccessori.get(0).titoloTabGruppo));
		this.buttonTab1.setCaption(this.l_VG.utilityTraduzioni.TraduciStringa("Liberi"));
		this.accessoriViewTutti.Nazionalizza();
		this.accessoriFreeView.Nazionalizza();
	}
	
	public void setVariabiliGlobali(final VariabiliGlobali variabiliGlobali) {
		this.l_VG = variabiliGlobali;
	    this.l_VG.ElencoMobileView[this.l_VG.AccessoriViewIndex] = null;
		//l_VG.AccessoriView = this;
	    this.accessoriViewTutti.setVariabiliGlobali(this.l_VG);
		this.accessoriFreeView.setVariabiliGlobali(this.l_VG);
	}
	
	private void resetColoreSelezionato() {
		resetColoreSelezionato(this.buttonTab0);
		resetColoreSelezionato(this.buttonTab1);
	}
	
	private void resetColoreSelezionato(final XdevButton bottone) {
		if (bottone.getStyleName().contains(this.coloreBottoneSelezionato)) {
			bottone.removeStyleName(this.coloreBottoneSelezionato);
			bottone.addStyleName(this.coloreBottone);
		}
	}
	/**
	 * Event handler delegate method for the {@link XdevButton}
	 * {@link #buttonTab0}.
	 *
	 * @see Button.ClickListener#buttonClick(Button.ClickEvent)
	 * @eventHandlerDelegate Do NOT delete, used by UI designer!
	 */
	private void buttonTab0_buttonClick(final Button.ClickEvent event) {
		resetColoreSelezionato();
		this.buttonTab0.removeStyleName(this.coloreBottone);
		this.buttonTab0.addStyleName(this.coloreBottoneSelezionato);
		this.gridLayout.removeComponent(0, 0);
		this.accessoriViewTutti.setSizeFull();
		this.gridLayout.addComponent(this.accessoriViewTutti, 0, 0);
	}

	/**
	 * Event handler delegate method for the {@link XdevButton} {@link #buttonTab1}.
	 *
	 * @see Button.ClickListener#buttonClick(Button.ClickEvent)
	 * @eventHandlerDelegate Do NOT delete, used by UI designer!
	 */
	private void buttonTab1_buttonClick(final Button.ClickEvent event) {
		resetColoreSelezionato();
		this.buttonTab1.removeStyleName(this.coloreBottone);
		this.buttonTab1.addStyleName(this.coloreBottoneSelezionato);
		this.gridLayout.removeComponent(0, 0);
		this.accessoriFreeView.setSizeFull();
		this.gridLayout.addComponent(this.accessoriFreeView, 0, 0);
	
	}

	/*
	 * WARNING: Do NOT edit!<br>The content of this method is always regenerated by
	 * the UI designer.
	 */
	// <generated-code name="initUI">
	private void initUI() {
		this.verticalLayout = new XdevVerticalLayout();
		this.horizontalLayout = new XdevHorizontalLayout();
		this.buttonTab0 = new XdevButton();
		this.buttonTab1 = new XdevButton();
		this.gridLayout = new XdevGridLayout();
		this.panelToRemove = new XdevPanel();
	
		this.verticalLayout.setMargin(new MarginInfo(false));
		this.horizontalLayout.setSpacing(false);
		this.horizontalLayout.setMargin(new MarginInfo(false));
		this.buttonTab0.setCaption("Tab0");
		this.buttonTab0.setStyleName("verde");
		this.buttonTab1.setCaption("Tab6");
		this.buttonTab1.setStyleName("verde");
		this.gridLayout.setMargin(new MarginInfo(false));
		this.panelToRemove.setTabIndex(0);
	
		this.buttonTab0.setSizeUndefined();
		this.horizontalLayout.addComponent(this.buttonTab0);
		this.horizontalLayout.setComponentAlignment(this.buttonTab0, Alignment.MIDDLE_CENTER);
		this.buttonTab1.setSizeUndefined();
		this.horizontalLayout.addComponent(this.buttonTab1);
		this.horizontalLayout.setComponentAlignment(this.buttonTab1, Alignment.MIDDLE_CENTER);
		final CustomComponent horizontalLayout_spacer = new CustomComponent();
		horizontalLayout_spacer.setSizeFull();
		this.horizontalLayout.addComponent(horizontalLayout_spacer);
		this.horizontalLayout.setExpandRatio(horizontalLayout_spacer, 1.0F);
		this.gridLayout.setColumns(1);
		this.gridLayout.setRows(1);
		this.panelToRemove.setSizeFull();
		this.gridLayout.addComponent(this.panelToRemove, 0, 0);
		this.gridLayout.setColumnExpandRatio(0, 10.0F);
		this.gridLayout.setRowExpandRatio(0, 10.0F);
		this.horizontalLayout.setWidth(100, Unit.PERCENTAGE);
		this.horizontalLayout.setHeight(40, Unit.PIXELS);
		this.verticalLayout.addComponent(this.horizontalLayout);
		this.verticalLayout.setComponentAlignment(this.horizontalLayout, Alignment.MIDDLE_CENTER);
		this.gridLayout.setSizeFull();
		this.verticalLayout.addComponent(this.gridLayout);
		this.verticalLayout.setComponentAlignment(this.gridLayout, Alignment.MIDDLE_CENTER);
		this.verticalLayout.setExpandRatio(this.gridLayout, 10.0F);
		this.verticalLayout.setSizeFull();
		this.setContent(this.verticalLayout);
		this.setSizeFull();
	
		this.buttonTab0.addClickListener(event -> this.buttonTab0_buttonClick(event));
		this.buttonTab1.addClickListener(event -> this.buttonTab1_buttonClick(event));
	} // </generated-code>

	// <generated-code name="variables">
	private XdevButton buttonTab0, buttonTab1;
	private XdevHorizontalLayout horizontalLayout;
	private XdevPanel panelToRemove;
	private XdevGridLayout gridLayout;
	private XdevVerticalLayout verticalLayout;
	// </generated-code>


}
